	
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */


// Pref variables - all will be overridden by adjustPrefs() _if_ the user has saved preferences
var prefsShown = false;
var numEntriesPerPage = 30;
var numGroupEntries = 3;
var showShortDesc = false;
var mainFontSize = 14;
var canvasWidthHeight = 12;
var movieDatabase = 'imdb';
var cacheInBackground = true;
var lastUsedVersion = 0;

var savedMode = 'single';
var savedNumShowsPerGroup = 4;

var secondsBeforeReminder = 120;
var reminderSound = null;
var growlSupport = 0;



function showPrefs() {
	if(0.98 > getObj('flip').opacity)
		return;
	
	var front = getObj("frontDiv");
	var back = getObj("prefDiv");
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
	
	hideDrawer();
	document.removeEventListener("keydown", keyPressed, false);			// used by scroller
	front.style.display = "none";
	back.style.display = "block";
	prefsShown = true;
	
	if('block' == getObj('WSprefs_layer_tuner').style.display) {
		adjustTunerSupport();
	}
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);	 
}

function hidePrefs() {
	var front = getObj("frontDiv");
	var back = getObj("prefDiv");
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
	
	document.addEventListener("keydown", keyPressed, false);
	front.style.display = "block";
	back.style.display = "none";
	prefsShown = false;
	
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
	
	if(!specialDisplayShown) {
		setTimeout("updateTVListing();", 10);
	}
}


// adjusts the Prefs
function adjustPrefs() {
	if(!window.widget)
		return;
	
	// create some buttons
	createGenericButton(getObj("tuner_start_button"), locStr("Sender zuweisen"), startTunerAndSwitchToPrefs, 120);
	createGenericButton(getObj("clear_cache_button"), locStr("Cache löschen"), clearCache);
	createGenericButton(getObj("repeat_automatic_allocation"), locStr("automatische Zuweisung wiederholen"), guessAllTunerChannels);
	try {
		getObj("tuner_start_button").firstChild.nextSibling.style.color = '#222';
		getObj("clear_cache_button").firstChild.nextSibling.style.color = '#222';
		getObj("repeat_automatic_allocation").firstChild.nextSibling.style.color = '#222';
	}
	catch(exc) {  }
	
	createGenericButton(getObj("filter_button_cancel"), locStr("Abbrechen"), hideNewFilterSheet);
	createGenericButton(getObj("filter_button_set"), locStr("Setzen"), saveFilter);
	
	createGenericButton(getObj("done"), locStr("Fertig"), savePrefs);
	
	
	// Saved states
	savedMode = widget.preferenceForKey("savedMode");
	savedNumShowsPerGroup = widget.preferenceForKey("savedNumShowsPerGroup");
	var foo = widget.preferenceForKey("searchOptions");
	if(foo) {
		foo = foo.split("|");
		if(foo.length > 0) {
			searchOptions = foo;
		}
	}
	
	
	// General options
	prefvalue = widget.preferenceForKey("numEntriesPerPage");
	numEntriesPerPage = prefvalue ? prefvalue : numEntriesPerPage;
	selectValue(getObj("numEntriesPerPage"), numEntriesPerPage);
	
	prefvalue = widget.preferenceForKey("numGroupEntries");
	numGroupEntries = prefvalue ? prefvalue : numGroupEntries;
	
	prefvalue = widget.preferenceForKey("showShortDesc");
	showShortDesc = prefvalue ? prefvalue : showShortDesc;
	getObj("showShortDesc").checked = showShortDesc ? true : false;
	
	prefvalue = widget.preferenceForKey("mainFontSize");
	mainFontSize = prefvalue ? prefvalue : mainFontSize;
	setMainFontSize();
	
	prefvalue = widget.preferenceForKey("movieDatabase");
	movieDatabase = prefvalue ? prefvalue : movieDatabase;
	selectValue(getObj("movieDatabase"), movieDatabase);
	
	prefvalue = widget.preferenceForKey("cacheInBackground");
	cacheInBackground = prefvalue ? prefvalue : cacheInBackground;
	getObj("cacheInBackground").checked = cacheInBackground ? true : false;
	
	// last version of the widget used
	lastUsedVersion = widget.preferenceForKey("LastUsedVersion");
	widget.setPreferenceForKey(getComparableVersionnumber(_version), "LastUsedVersion");
	
	
	// Tuner Support
	prefvalue = widget.preferenceForKey("tunerUsed");
	tunerUsed = prefvalue ? prefvalue : tunerUsed;
	tunerChannelsAssignedFor = tunerUsed;
	tunerSupportToggled(tunerUsed);
	
	// Growl -- check if it works with 2.0
	prefvalue = widget.preferenceForKey("growlSupport");
	growlSupport = (prefvalue && (prefvalue == "1") && FernsehPlugin.canUseGrowlNotification()) ? true : false;
	getObj("growlSupport").checked = growlSupport;
	FernsehPlugin.setUsesGrowlNotification(growlSupport);	// no reason to worry, even if set to true, the plugin ignores this if Growl is not installed/running
	if(!FernsehPlugin.canUseGrowlNotification()) {
		getObj("growlSupport").disabled = true;
		getObj("growlSupport").nextSibling.setAttribute('class', 'clicksel disabled');
	}
	
	// Alerts
	prefvalue = widget.preferenceForKey("reminder");
	secondsBeforeReminder = prefvalue ? prefvalue : secondsBeforeReminder;
	selectValue(getObj("reminder"), secondsBeforeReminder);
	FernsehPlugin.setSecondsBeforeReminder(secondsBeforeReminder);
	
	// unsupported ;)
	
	
	// alert sounds
	populateAlertSounds();
}


// switch the tabs of the prefs
function switchToPrefSection(section) {
	if('channels' == section) {
		loadAllChannels();
	}
	else {
		saveChannelGroupings();
	}
	
	if('filters' == section) {
		addAssignedChannelsToSelector('filter_only_channel', 'filter_list');
	}
	else if('tuner' == section) {
		adjustTunerSupport();					// updates the list of the channels, too
	}
	
	var poss = getElementNodes(getObj('WSprefs_tabBar'));
	
	for(i = 0; i < poss.length; i++) {
		if('div' == poss[i].nodeName.toLowerCase()) {
			var tab = poss[i];
			var this_section = tab.id.substring(12);		// Strips the "WSprefs_tab_" part to get the section-name
			
			// the clicked tab
			if(this_section == section) {
				tab.setAttribute('class', "WSprefs_tabActive");
				getObj("WSprefs_layer_" + this_section).style.display = 'block';
			}
			
			// other tab(s)
			else {
				tab.setAttribute('class', "WSprefs_tabInactive");
				getObj("WSprefs_layer_" + this_section).style.display = 'none';
			}
		}
	}
}



function savePrefs() {
	if(window.widget) {
		
		// basic options
		showShortDesc = getObj("showShortDesc").checked;
		widget.setPreferenceForKey(showShortDesc, "showShortDesc");
		
		mainFontSize = (mainFontSize >= 8 && mainFontSize <= 40) ? mainFontSize : 14;
		widget.setPreferenceForKey(mainFontSize, "mainFontSize");
		setMainFontSize();
		
		// save num channels to display
		opt = getObj("numEntriesPerPage");
		numEntriesPerPage = Math.abs(opt.options[opt.selectedIndex].value);
		numEntriesPerPage = (numEntriesPerPage > 0 && numEntriesPerPage <= 100) ? numEntriesPerPage : 30;
		widget.setPreferenceForKey(numEntriesPerPage, "numEntriesPerPage");
		
		cacheInBackground = getObj("cacheInBackground").checked;
		widget.setPreferenceForKey(cacheInBackground, "cacheInBackground");
		
		opt = getObj("reminder");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "reminder");
		
		opt = getObj("movieDatabase");
		movieDatabase = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(movieDatabase, "movieDatabase");
		
		// save channel groupings
		saveChannelGroupings();
		
		// save filters (saveFilters() decides itself if saving is necessary)
		saveFilters();
		
		// save tuner support
		widget.setPreferenceForKey(tunerUsed, "tunerUsed");
		saveTunerChannelAssigns();
		
		// Growl
		growlSupport = (getObj("growlSupport").checked ? "1" : "0");
		widget.setPreferenceForKey(growlSupport, "growlSupport");
		
		if(FernsehPlugin && FernsehPlugin.canUseGrowlNotification()) {
			FernsehPlugin.setUsesGrowlNotification(growlSupport);
		}
		
		// clean from old prefs from version 1.x
		widget.setPreferenceForKey(null, "eyetvChannels");
		widget.setPreferenceForKey(null, "eyetvEnabled");
		widget.setPreferenceForKey(null, "formacEnabled");
		widget.setPreferenceForKey(null, "defaultChannelGroup");
		widget.setPreferenceForKey(null, "numDaysToPrecache");
		widget.setPreferenceForKey(null, "day");
		widget.setPreferenceForKey(null, "hour");
	}
	
	hidePrefs();
}



// changes the main font size.
function setMainFontSize() {
	if(mainFontSize) {
		var body = document.getElementsByTagName('body');
		body[0].setAttribute("style", "font-size:" + mainFontSize + "px");
		
		canvasWidthHeight = mainFontSize;
		setFontsizeSliderTo(mainFontSize);
	}
}

// called when clicking the (+) or (-) in grouped mode
function changeNumGroupEntries(amount)
{
	var clickedHeader = event.currentTarget.parentNode.parentNode.id;
	var clickOffset = event.y - 50;		// Hardcode the amount of the Top-Margin
	
	var amt = parseInt(amount);
	numGroupEntries += amt;
	widget.setPreferenceForKey(numGroupEntries, "numGroupEntries");
	takePreparedData();
	
	// scroll to position
	var topoffset = getObj(clickedHeader).offsetTop;
	getObj("content").style.top = ((topoffset - clickOffset) * -1) + "px";
	calculateAndShowThumb('myScrollBar', getObj("content"));
}


function reminderSoundChanged(dont_play) {
	var opt = getObj("reminderSound");
	var optval = opt.options[opt.selectedIndex].value;
	if(!optval)
		return;
	
	reminderSound = optval;
	if(FernsehPlugin) {
		FernsehPlugin.setTimerSound(reminderSound);
	}
	
	// generate the alert embed
	if(getObj("currentAlertSoundEmbed")) {
		getObj("currentAlertSoundEmbed").parentNode.removeChild(getObj("currentAlertSoundEmbed"));
	}
	
	// default alert-sound chosen; no need to generate anything
	if(reminderSound.search(/\/(none|root)\/.*/) == -1) {
		var soundPlayer = document.createElement("embed");
		soundPlayer.setAttribute("id", "currentAlertSoundEmbed");
		soundPlayer.setAttribute("src", reminderSound);
		soundPlayer.setAttribute("autostart", "false");
		soundPlayer.setAttribute("hidden", "true");
		soundPlayer.setAttribute("enablejavascript", true);
		getObj('soundsParent').appendChild(soundPlayer);
	}
	
	if(!dont_play) {
		playReminderSound();
	}
}

function playReminderSound() {
	if(!reminderSound || '/none/' == reminderSound.substr(0, 6)) {
		return;
	}
	else if('/root/' == reminderSound.substr(0, 6) && window.widget) {
		FernsehPlugin.beep();
		return;
	}
	
	var soundPlayer = getObj('currentAlertSoundEmbed');
	if(soundPlayer) {
		soundPlayer.Play();
	}
	else if(window.widget) {
		FernsehPlugin.beep();
	}
}


function reminderIntervalChanged()
{
	var opt = getObj("reminder");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(""+optval);
}


// localizes the strings in the Prefs
function localizePrefs() {
	var string_arr = new Array('string_Generelles', 'string_Sender', 'string_Filter', 'string_Alarme', 'string_channelGroup1', 'string_channelGroup2', 'string_Sendungen_pro_Seite', 'string_Hauptschriftgroesse', 'string_Kurzinfos', 'string_Filmdatenbank', 'string_cacheInBackground', 'string_Filtern_nach', 'string_nur_im_Titel', 'string_auch_bei_Mitwirkenden', 'string_markieren', 'string_TV_Software', 'optval_KeineSoftware', 'string_Alarm_setzen', 'optval_Keine', 'optval_1_Minute', 'optval_2_Minuten', 'optval_5_Minuten', 'optval_10_Minuten', 'optval_15_Minuten', 'string_Zeit_vor_Alarm', 'string_Alarmton', 'string_Growl_verwenden', 'string_muss_installiert_sein', 'string_Hilfe');
	
	// loop these strings
	for(var i = 0; i < string_arr.length; i++) {
		var key = string_arr[i].replace(/^(string|optval2?)_/i, '');
		try {
			getObj(string_arr[i]).innerHTML = locStr(key);
		}
		catch(exc) {
			alert("Could not localize " + string_arr[i] + " (" + key + ")");
		}
	}
	
	// special strings
	try {
		getObj('filtersHint').innerHTML = locStr('Filter hinzufügen');
		getObj('searchInput').setAttribute('placeholder', locStr("Suche"));
	}
	catch(exc) {
		alert("Could not localize some strings: " + exc);
	}
}


// does what the name suggests
function populateAlertSounds() {
	var static_sounds = new Array();
	static_sounds.push("/none/Kein Ton");
	static_sounds.push("/root/Systemton");
	var alarmSound = FernsehPlugin.timerSound();
	var selector = getObj('reminderSound');
	var sounds = FernsehPlugin.validSounds();
	
	var currentLibrary = 'none';
	for(i = (-1 * static_sounds.length); i < sounds.length; i++) {
		var snd = (i < 0) ? static_sounds[static_sounds.length + i] : sounds[i];
		var components = snd.split("/");
		var soundname = components.pop();
		var lib = components.join('/');
		
		// new library; add separator
		if(currentLibrary != components[1]) {
			if(has1043Features())
				var separator = document.createElement("hr");
			else {
				var separator = document.createElement("option");
				separator.value = '';
				separator.innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
			}
			selector.appendChild(separator);
		}
		
		// add new sound-option
		if(i < 0) {
			soundname = locStr(soundname);
		}
		else {
			soundname = (soundname.indexOf(".", soundname.length - 6) > -1) ? soundname.substring(0, soundname.indexOf(".", soundname.length - 6)) : soundname;
		}
		
		var newoption = document.createElement("option");
		newoption.value = snd;
		newoption.innerHTML = (soundname.length > 0) ? soundname : "no soundname given";
		if(snd == alarmSound) {
			newoption.selected = true;
			reminderSound = snd;
		}
		
		selector.appendChild(newoption);
		
		currentLibrary = components[1];
	}
	
	reminderSoundChanged(true);
}
