/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */

/***********
 * Toolbar *
 ***********/

// used for ignoring mouseEnter once, useful after closing filters, alarms, ...
var ignoreMouseEnteredOnce = false;

// these are the different toolbars we have
var toolbarSetup = new Array();
toolbarSetup['standard'] = new Array('toolbarGroup1', 'toolbarGroup2', '#', 'toolbarDay', '#', 'toolbarNow', 'toolbarPrimetime');
toolbarSetup['help'] = new Array('closeHelp');
toolbarSetup['alerts'] = new Array('closeAlerts');
toolbarSetup['filtered'] = new Array('closeFilters');
toolbarSetup['personShows'] = new Array('closePersonShows');

// these are the toolbar items themselves. Their definitions: arr[0] = text, arr[1] = type, arr[2] = performing key, arr[3] = setting this value
var toolbarItems = new Object();
var toolbarItemDefinition = new Array();
var toolbarPopupDefinition = new Array();
toolbarItemDefinition['toolbarGroup1'] =	new Array("1",							'channelSwitch',	'channelsOfGroup',	1);
toolbarItemDefinition['toolbarGroup2'] =	new Array("2",							'channelSwitch',	'channelsOfGroup',	2);
toolbarItemDefinition['toolbarDay'] =		new Array(locStr("Heute"),				'daySwitch',		'day',				'0');
toolbarItemDefinition['toolbarNow'] =		new Array(locStr("Jetzt"),				'timeSwitch',		'time',				'now');
toolbarItemDefinition['toolbarPrimetime'] =	new Array(locStr("Abend"),				'timeSwitch',		'time',				'primetime');
toolbarItemDefinition['closeHelp'] =		new Array(locStr("Hilfe schliessen"),	'closeButton',		'closeSpecial');
toolbarItemDefinition['closeAlerts'] =		new Array(locStr("Alarme schliessen"),	'closeButton',		'closeSpecial');
toolbarItemDefinition['closeFilters'] =		new Array(locStr("Filter schliessen"),	'closeButton',		'closeSpecial');
toolbarItemDefinition['closePersonShows'] =	new Array(locStr("Schliessen"),			'closeButton',		'closeSpecial');

toolbarPopupDefinition['toolbarGenrePopup'] = new Array(	new Array('',				locStr('alle Genres')),
															new Array('#topGenres',		'#topGenres'),
															new Array('#showFiltered',	locStr('gefilterte Sendungen')),
															new Array('#showAlerts',	locStr('Alle Alarme')),
															new Array('#showHelp',		locStr('Hilfe und FAQ'))
														);


// feed the genres to the toolbarItem responsible for them. It will display them when the user hovers the menu.
function setupToolbarGenres()
{
	if(toolbarItems['toolbarGenrePopup']) {
		var topGenres = new Array();
		var genreid = FernsehPlugin.topGenres(5);
		for (var i = 0; i < genreid.length; i++)
		{
			topGenres.push(genreid[i]);
		}
		toolbarItems['toolbarGenrePopup'].topGenres = topGenres;
		
		var allGenres = new Array();
		var genreid = FernsehPlugin.genres();
		for (var i = 0; i < genreid.length; i++)
		{
			allGenres.push(genreid[i]);
		}
		toolbarItems['toolbarGenrePopup'].allGenres = allGenres;
	}
}



// the toolbar object
function toolbarItem(id) {
	if(! this instanceof toolbarItem) {
		return new toolbarItem(id);
	}
	
	var def = toolbarItemDefinition[id] ? toolbarItemDefinition[id] : null;
	if(null == def)
		return null;
	
	if(toolbarItems[id]) {
		return toolbarItems[id];	// does already exist
	}
	
	
	// Attributes
	this.id = id;
	this.title = def[0];
	
	this.type = def[1];							// Supported: channelSwitch, daySwitch, timeSwitch, closeButton
	this.setkey = def[2];						// the hash-key of "displaySetting" which gets altered. If 'closeButton' is the type, the name of the Function comes here
	this.setvalue = def[3] ? def[3] : false;
	
	this.state = (displaySetting[this.setkey] && this.setvalue == displaySetting[this.setkey]) ? 'active' : 'ready';			// ready - active - inactive
	if('closeButton' == this.type) {
		this.state = 'active';
	}
	
	this.div = null;
	this.parent = getObj('toolbar');
	
	
	// Methods
	this.getXHTML = function() {
		var div = document.createElement('div');
		div.setAttribute('class', ('daySwitch' == this.type ? 'toolbarItemNoHover' : 'toolbarItem') + ('active' == this.state ? ' toolbarItemActive' : ''));
		div.setAttribute('onclick', "toolbarItemClicked(event, '" + this.id + "')");
		div.setAttribute('lang', this.id);
		
		if('daySwitch' == this.type) {
			div.setAttribute('onmouseover', "toolbarItemHovered(event)");
		}
		
		if('closeButton' == this.type) {
			div.innerHTML = '✕ ' + this.title;
		}
		else {
			div.innerHTML = this.title;
		}
		return div;
	}
	
	this.addToToolbar = function() {
		if(this.div) {
			this.parent.appendChild(this.div);
		}
	}
	
	// called when an item is clicked
	this.clicked = function(event) {
		var shiftKey = (('channelSwitch' == this.type) && event && event.shiftKey);
		
		// clicking an INACTIVE item
		if('ready' == this.state) {
			this.activate(shiftKey);
		}
		
		// clicking an ACTIVE item
		else if('active' == this.state) {
			if(shiftKey) {
				this.deactivate(true);
			}
			else {
				this.activate();			// can not deactivate this item, treat as if clicked while inactive
			}
		}
	}
	
	// called when a day is clicked
	this.listClicked = function(dayOffset) {
		if('daySwitch' == this.type) {
			displaySetting[this.setkey] = dayOffset;
			
			this.unhover();
			setTimeout("updateTVListing()", 10);
		}
	}
	
	// make active
	this.activate = function(toggle_instead_of_switch) {
		if('closeButton' == this.type) {
			switch(this.setkey) {
				case 'closeSpecial':
				{
					// in case the mouse is at the place where a menu would immediately shown, ignore this
					// mouseEnter once. -- if the mouse is not there, reset this after a second
					ignoreMouseEnteredOnce = true;
					setTimeout("resetIgnoreMouseEnteredOnce()", 1000);
					hideSpecialContent(true);
					break;
				}
				default:					alert("Action undefined");			break;
			}
			return;
		}
		
		// toggle the day
		if('daySwitch' == this.type) {
			this.hover();
		}
		
		// deactivate the other items with the same key (unless shift-key is pressed)
		else if(!toggle_instead_of_switch) {
			for(var p in toolbarItems) {					
				if(toolbarItems[p] != this && toolbarItems[p].type == this.type) {
					toolbarItems[p].deactivate();
				}
			}	
		}
		
		// set the value
		if('channelSwitch' == this.type) {
			displaySetting[this.setkey] += 1*this.setvalue;
		}
		else {
			displaySetting[this.setkey] = this.setvalue;
		}
		
		this.displayActive();
		
		// use the timeswitch to scroll the magazine view
		if(('timeSwitch' == this.type) && ('magazine' == displaySetting['mode'])) {
			scrollMagazineViewTo(this.setvalue);
		}
		else {
			setTimeout("updateTVListing()", 10);
		}
	}
	this.displayActive = function() {
		this.div.setAttribute('class', "toolbarItem toolbarItemActive");
		this.state = 'active';
	}
	
	// deactivate
	this.deactivate = function(action) {
		if('channelSwitch' == this.type) {
			if('active' == this.state) {
				displaySetting[this.setkey] -= 1*this.setvalue;
			}
			displaySetting[this.setkey] = (action && displaySetting[this.setkey] < 1) ? 1 : displaySetting[this.setkey];		// prevent de-selecting both channelgroups
		}
		else {
			displaySetting[this.setkey] = false;
		}
		
		this.displayInactive();
		if(action) {
			setTimeout("updateTVListing()", 10);
		}
	}
	this.displayInactive = function() {
		this.div.setAttribute('class', "toolbarItem");
		this.state = 'ready';
	}
	
	// updates its state from the current settings
	this.update = function(forceFirstShowStamp) {
		if('daySwitch' == this.type) {
			var stamp = forceFirstShowStamp ? forceFirstShowStamp : firstShowStamp;
			var dayOffset = dateDifference(new Date(), stamp);
			dayOffset = (dayOffset < 0) ? 0 : dayOffset;
			
			var name = locStr("Heute");
			if(1 == dayOffset) {
				name = locStr("Morgen");
			}
			else if(dayOffset > 1) {
				var timestamp = new Date();
				timestamp.setDate(timestamp.getDate() + 1*dayOffset);
				name = localizedWeekday(timestamp);
			}
			
			this.div.innerHTML = name;
		}
		else if('timeSwitch' == this.type) {
			if((displaySetting[this.setkey] == this.setvalue) && (displaySetting['offset'] == 0)) {
				this.displayActive();
			}
			else {
				this.displayInactive();
			}
		}
		else if('channelSwitch' == this.type) {
			if((displaySetting[this.setkey] == this.setvalue) || (3 == displaySetting[this.setkey])) {
				this.displayActive();
			}
			else {
				this.displayInactive();
			}
		}
	}
	
	// hovering
	this.hover = function() {
		if(isCollapsed())
			return;
		
		if('daySwitch' == this.type) {
			var parent = document.createElement('div');				// this will cover the whole widget
			parent.setAttribute('class', "toolbarListParent");
			parent.setAttribute('lang', this.id);
			parent.addEventListener('mouseover', toolbarItemLeft, null);
			
			var list = document.createElement('div');
			list.setAttribute('class', "toolbarList");
			list.style.marginLeft = (this.div.offsetLeft + 1*9) + 'px';		// align first entry with entry in the toolbar
			
			// calculate which day is the first of the page
			var dayOffset = dateDifference(new Date(), firstShowStamp);
			dayOffset = (dayOffset < 0) ? 0 : dayOffset;
			if('magazine' == displaySetting['mode'] && magazineViewIsOnNextDay) {
				dayOffset += 1;
			}
			
			// generate an entry for every possible day
			for(var i = 0; i <= numDaysToPrecache; i++) {
				var item = document.createElement('div');
				item.setAttribute('lang', i);
				item.addEventListener('click', toolbarListItemClicked, null);
				
				var name = locStr("Heute");
				if(1 == i) {
					name = locStr("Morgen");
				}
				else if(i > 1) {
					var timestamp = new Date();
					timestamp.setDate(timestamp.getDate() + i);
					name = localizedWeekday(timestamp);
				}
				
				if(i == dayOffset) {
					item.setAttribute('class', "toolbarListItem toolbarListItemActive");
					//this.div.innerHTML = name;
				}
				else {
					item.setAttribute('class', "toolbarListItem");
				}
				
				item.innerHTML = name;
				list.appendChild(item);
			}
			
			parent.appendChild(list);
			
			this.list = parent;
			getObj('frontDiv').appendChild(parent);
		}
	}
	
	this.unhover = function() {
		if(this.list) {
			this.list.parentNode.removeChild(this.list);
			this.list = null;
		}
	}
	
	// init
	this.div = this.getXHTML();
	
	toolbarItems[this.id] = this;
	return this;
}



// the toolbar popup class
function toolbarPopup(id) {
	if(! this instanceof toolbarPopup) {
		return new toolbarPopup(id);
	}
	
	var def = toolbarPopupDefinition[id] ? toolbarPopupDefinition[id] : null;
	if(null == def)
		return null;
	
	if(toolbarItems[id]) {
		toolbarItems[id].update();
		return toolbarItems[id];	// does already exist
	}
	
	// Attributes
	this.id = id;
	this.staticOptions = def;				// an array of arrays. Each array is an option-array, option-array[0] = id, option-array[1] = text
	this.topGenres = new Array();
	this.allGenres = new Array();
	
	this.div = null;
	this.parent = getObj('toolbar');
	
	// Methods
	this.getXHTML = function() {
		var div = document.createElement('div');
		div.setAttribute('id', this.id);
		div.setAttribute('class', "toolbarPopupDiv");
		div.setAttribute('lang', this.id);
		div.setAttribute('onmouseover', "toolbarItemHovered(event)");
		
		return div;
	}
	
	this.addToToolbar = function() {
		if(this.div) {
			this.parent.appendChild(this.div);
		}
	}
	
	this.removeFromToolbar = function() {
		if(this.parent && this.div) {
			this.parent.removeChild(this.div);
		}
	}
	
	// actions
	this.clicked = function() {
		this.hover();
	}
	
	this.activateOption = function(param) {
		param = param ? param : '';
		displaySetting['genre'] = param;
		displaySetting['mode'] = "single";
		displaySetting['offset'] = 0;
		
		var force_starttime = '';
		if(displaySetting['time'].match(/:/)) {
			var foo = displaySetting['time'].split(/:/);
			var bar = new Date();
			bar.setDate(bar.getDate() + 1* displaySetting['day']);
			bar.setHours(foo[0]);
			bar.setMinutes(foo[1]);
			force_starttime = bar.getTime();
		}
		
		switch(param) {
			case '#showFiltered':	displaySpecialContent('filtered');									break;
			case '#showAlerts':		displaySpecialContent('alerts');									break;
			case '#showHelp':		displaySpecialContent('help');										break;
			case '':				setTimeout(isSearchResult ? "immediateSearch('" + ourSearchString + "')" : "updateTVListing(" + force_starttime + ")", 10);
									break;
			default:				setTimeout(isSearchResult ? "immediateSearch('" + ourSearchString + "')" : "updateTVListing(" + force_starttime + ")", 10);
									break;
		}
		
		this.unhover();
	}
	
	this.listClicked = function(param) {
		this.activateOption(param);
	}
	
	// hovering
	this.hover = function() {
		if(isCollapsed())
			return;
		
		var parent = document.createElement('div');
		parent.setAttribute('class', "toolbarListParent");
		parent.setAttribute('lang', this.id);
		parent.addEventListener('mouseover', toolbarItemLeft, null);
		
		var list = document.createElement('div');
		list.setAttribute('class', "toolbarList");
		list.style.width = "170px";
		list.style.marginLeft = "auto";
		list.style.marginRight = "18px";
		
		// generate an entry for the most "valuable" genres
		for(var i = 0; i < this.staticOptions.length; i++) {
			if('#topGenres' == this.staticOptions[i][0]) {
				var spacer = document.createElement('div');
				spacer.setAttribute('class', "toolbarListSpacer");
				list.appendChild(spacer);
				
				// look for the "Spielfilm" genre. We want this genre to be in the top genres for sure.
				var topGenreArray = new Array();
				if(this.allGenres) {
					var SpielfilmFound = false;
					for(var a = 0; a < this.allGenres.length; a++) {
						if(inArray(this.allGenres[a], this.topGenres)) {
							topGenreArray.push(this.allGenres[a]);
						}
						else if(!SpielfilmFound && FernsehPlugin.nameOfGenreWithID(this.allGenres[a]) && FernsehPlugin.nameOfGenreWithID(this.allGenres[a]).match(/Spielfilm/)) {
							SpielfilmFound = true;
							topGenreArray.push(this.allGenres[a]);
						}
					}
				}
				
				// top genres
				for(var v = 0; v < topGenreArray.length; v++) {
					var genre_id = topGenreArray[v];
					var item = document.createElement('div');
					item.setAttribute('class', "toolbarListItem" + ((displaySetting['genre'] == genre_id) ? " toolbarListItemActive" : ''));
					item.setAttribute('lang', genre_id);
					item.addEventListener('click', toolbarListItemClicked, null);
					item.innerHTML = FernsehPlugin.nameOfGenreWithID(genre_id);	// + " (" + FernsehPlugin.numberOfShowsInGenreWithID(genre_id) + ")";
					
					list.appendChild(item);
				}
				
				// all genres
				if(this.allGenres) {
					var select = document.createElement('select');
					select.setAttribute('id', "allGenresSelect");
					select.addEventListener('change', toolbarPopupItemClicked, null);
					
					var cover = document.createElement('div');
					cover.setAttribute('id', "allGenresCover");
					cover.innerHTML = locStr("andere...");
					
					// placeholder for the first spot
					var opt = document.createElement('option');
					opt.value = '';
					opt.innerHTML = locStr("wähle...");
					select.appendChild(opt);
					
					// list all other genres
					for(var a = 0; a < this.allGenres.length; a++) {
						var genre_id = this.allGenres[a];
						if(!inArray(this.allGenres[a], topGenreArray)) {			// skip top-genres in the popup
							var opt = document.createElement('option');
							opt.value = genre_id;
							opt.innerHTML = FernsehPlugin.nameOfGenreWithID(genre_id);// + " (" + FernsehPlugin.numberOfShowsInGenreWithID(genre_id) + ")";
							select.appendChild(opt);
							
							if(genre_id == displaySetting['genre']) {
								opt.selected = true;
								cover.setAttribute('class', "toolbarListItemActive");
								cover.innerHTML = FernsehPlugin.nameOfGenreWithID(genre_id);
							}
						}
					}
					
					list.appendChild(select);
					list.appendChild(cover);
				}
				
				list.appendChild(spacer.cloneNode());
			}
			
			// static entry (like 'all genres' and 'all alerts')
			else {
				var option_id = this.staticOptions[i][0];
				var item = document.createElement('div');
				item.setAttribute('class', "toolbarListItem" + ((displaySetting['genre'] == option_id) ? " toolbarListItemActive" : ''));
				item.setAttribute('lang', option_id);
				item.addEventListener('click', toolbarListItemClicked, null);
				item.innerHTML = this.staticOptions[i][1];
				
				list.appendChild(item);
			}
		}
		
		parent.appendChild(list);
		
		this.list = parent;
		getObj('frontDiv').appendChild(parent);
	}
	
	this.unhover = function() {
		if(this.list) {
			this.list.parentNode.removeChild(this.list);
			this.list = null;
		}
	}
	
	// guesses its state from the current settings
	this.update = function(facultative_genre) {
		this.div.setAttribute('class', "toolbarPopupDiv");
		
		var inner = specialDisplayShown ? specialDisplayShown : (facultative_genre ? facultative_genre : displaySetting['genre']);
		if('' == inner) {
			inner = locStr("alle Genres");
		}
		else if('x-coredata' == inner.substr(0, 10)) {
			inner = FernsehPlugin.nameOfGenreWithID(displaySetting['genre']);
			this.div.setAttribute('class', "toolbarPopupDiv toolbarPopupDivActive");
		}
		else {
			inner = locStr("Menü");
		}
		
		this.div.innerHTML = inner;
	}
	
	// init
	this.div = this.getXHTML();
	
	toolbarItems[this.id] = this;
	return this;
}


// generates (if necessary) and displays the desired toolbar setup
function initToolbar(setup) {
	if(!setup || !toolbarSetup[setup]) {
		alert("initToolbar(): We have no setup, defaulting to 'standard'");
		setup = 'standard';
	}
	
	var toolbar = getObj('toolbar');
	if(toolbar) {
		// remove old items (don't use "cleanNode" here, we keep the popup)
		var old = getElementNodes(toolbar);
		for(var i = 0; i < old.length; i++) {
			var cls = old[i].getAttribute('class');
			if('toolbarPopupDiv' != cls) {
				toolbar.removeChild(old[i]);
			}
		}
		
		// add new items
		var items = toolbarSetup[setup];
		for(var i = 0; i < items.length; i++) {
			if('#' == items[i]) {
				var div = document.createElement('div');
				div.setAttribute('class', 'toolbarSeparator');
				toolbar.appendChild(div);
			}
			else {
				var item = new toolbarItem(items[i]);		// if it has already been generated, it returns itself instead
				item.addToToolbar();
			}
		}
		
		// the popup
		var pop = new toolbarPopup('toolbarGenrePopup');
		pop.addToToolbar();
	}
}



// updates the visual states of all toolbar items.
function toolbarUpdate(force_all) {
	for(var id in toolbarItems) {
		toolbarItems[id].update(force_all);
	}
}

function toolbarItemClicked(event, id) {
	if(toolbarItems && toolbarItems[id]) {
		toolbarItems[id].clicked(event);
	}
}

function toolbarListItemClicked(event) {
	var id = event.target ? event.target.parentNode.parentNode.lang : false;
	var param = event.target ? event.target.lang : false;
	
	if(id && toolbarItems && toolbarItems[id]) {
		toolbarItems[id].listClicked(param);
	}
}

function toolbarPopupItemClicked(event) {
	var id = event.target ? event.target.parentNode.parentNode.lang : false;
	var param = event.target ? event.target.value : false;
	
	if(id && toolbarItems && toolbarItems[id]) {
		toolbarItems[id].listClicked(param);
	}
}

function toolbarItemHovered(event) {
	// in case the "close..." was clicked while over the place where the menu for the days would be shown
	// ignore this once, otherwise the menu would show up immediately
	if (ignoreMouseEnteredOnce)
	{
		ignoreMouseEnteredOnce = false;
		return;
	}

	var id = event.target ? event.target.lang : false;
	
	if(id && toolbarItems && toolbarItems[id]) {
		toolbarItems[id].hover();
	}
}

function toolbarItemLeft(event) {
	var id = event.target ? event.target.lang : false;
	
	if(id && ('toolbarListParent' == event.target.className) && toolbarItems && toolbarItems[id]) {
		toolbarItems[id].unhover();
	}
}

function toolbarPopupClicked(event, id) {
	if(toolbarItems && toolbarItems[id]) {
		toolbarItems[id].clicked(event);
	}
}

function resetIgnoreMouseEnteredOnce()
{
	ignoreMouseEnteredOnce = false;
}
