/*
 ****************************
 *     Version checking     *
 *    by widgetschmie.de    *
 ****************************
 */


var _version = 0;
var PACKAGE_NAME = "Fernsehen";
var PACKAGE_ONLINEDIR = "Fernsehen";


function showVersion(ver) {
	if(getObj('infospan')) {
		getObj('infospan').innerHTML = PACKAGE_NAME + " " + (ver ? getBeautifulVersionnumber(ver) : '');
	}
}


// returns the current version number from the Info.plist
function getCurrentVersion() {
	var localReq = new XMLHttpRequest(); 
	localReq.open("GET", "Info.plist", false); 
	localReq.send(null); 
	
	var infoPlist = localReq.responseText; 
	
	var versionRegEx = /<key>CFBundleVersion<\/key>\s*<string>([^<]*)<\/string>/;
	var versionRaw = infoPlist.match(versionRegEx);
	var thisVersion = versionRaw[1];
	
	if(undefined == thisVersion) {
		alert("An error occurred while checking the local version. Assuming local version up-to-date.");
		return 0;
	}
	
	return thisVersion;
}

	// returns the version-number in a comparable form
	// we support version-numbering with up to 3 dots, e.g. 1.8.1.4
	// the last 2 steads support up to --6-- numbers, first 2 up to --3--
	// 1.8.1.4 becomes 1 008 000001 000004
function getComparableVersionnumber(ver) {
	var prts = ver ? ver.toString().split(/\./) : new Array();
	var version = (prts[0] * 1000000 * 1000000 * 1000) +
						(prts[1] ? (prts[1] * 1000000 * 1000000) : 0) +
						(prts[2] ? (prts[2] * 1000000) : 0) +
						(prts[3] ? (prts[3] * 1) : 0);
	return version;
}

	// returns a human readable versionnumber, from original version or comparable versionnumber
	// 1.8.060429 becomes 1.8.beta
	// 1008000001000000 becomes 1.8.1
function getBeautifulVersionnumber(ver) {
	if(!ver) {
		return "0.0";
	}
	
	// internal version number
	if(ver > 1000000) {
		var parts = new Array();
		
		parts[3] = ver % 1000000;
		ver = (ver - parts[3]) / 1000000;
		parts[2] = ver % 1000000;
		ver = (ver - parts[2]) / 1000000;
		parts[1] = ver % 1000;
		ver = (ver - parts[1]) / 1000;
		parts[0] = ver % 1000;
	}
	
	// raw number
	else {
		var parts = ver.toString().split(/\./);
	}
	
	// compose
	var version = (parts[3] > 0) ? ((parts[3] > 1000) ? 'beta' : parts[3]) : undefined;
	version = (parts[2] > 0) ? (((parts[2] > 1000) ? 'beta' : parts[2]) + (version ? ("." + version) : '')) : ((undefined == version) ? undefined : 0 + "." + version);
	version = (parts[1] > 0) ? (parts[1] + (version ? ("." + version) : '')) : ((undefined == version) ? undefined : "0." + version);
	version = (parts[0] > 0) ? (parts[0] + (version ? ("." + version) : '.0')) : ((undefined == version) ? undefined : "0." + version);
	
	return version;
}


// checks the latest version online. Call this Method!
latest_obj = null
latestVersionResetTimer = null;

function checkLatestVersion(link) {
	if(latestVersionResetTimer) {
		clearTimeout(latestVersionResetTimer);
		latestVersionResetTimer = null;
	}
	latest_obj = getObj(link);
	if(latest_obj) {
		latest_obj.innerText = "checking...";
	}
	
	var ajax = new simpleAjaxRequest("http://widgetschmie.de/widgets/" + PACKAGE_ONLINEDIR + "/latest.xml", setLatestVersion);
	if(!ajax) {
		latest_obj.innerHTML = "ajax-error";
	}
}


// receives the latest versionnumber; do not call directly
function setLatestVersion(latest_xml) {
	if(latestVersionResetTimer) {
		clearTimeout(latestVersionResetTimer);
		latestVersionResetTimer = null;
	}
	if(null == latest_xml) {
		if(latest_obj) {
			latest_obj.innerHTML = "no network";
			latestVersionResetTimer = setTimeout("resetLatestVersionCheck()", 10000);
		}
		return;
	}
	
	// parse the XML
	var root = latest_xml.documentElement;
	var elements = getElementNodes(root);
	var latest;
	var description;
	var description_en;
	
	for(var i = 0; i < elements.length; i++) {
		var tag = elements[i].tagName.toLowerCase();
		var msg = elements[i].textContent;
		
		// version
		if('latest' == tag) {
			latest = msg ? getComparableVersionnumber(msg) : 0;
		}
		
		// text
		else if('desc' == tag) {
			var lang = elements[i].getAttribute('lang');
			if(LANG == lang) {
				description = msg;
			}
			else if('en' == lang) {
				description_en = msg;
			}
		}
	}
	
	description = description ? description + "<br /><br />" : (description_en ? description_en + "<br /><br />" : '');
	
	// error
	if(isNaN(latest)) {
		if(latest_obj) {
			latest_obj.innerHTML = "error";
			latestVersionResetTimer = setTimeout("resetLatestVersionCheck()", 10000);
		}
	}
	
	// compare the version with this version
	else {
		var myVersion = _version ? getComparableVersionnumber(_version) : 0;
		var up_to_date = (latest == myVersion) ? "You are up to date" : ("Latest: " + getBeautifulVersionnumber(latest));
		
		// show the message (or alert it if there is no object to display the message with)
		if(latest_obj) {
			latest_obj.innerHTML = up_to_date;
		}
		
		// Show Dialog
		if(latest > myVersion) {
			showDialog(locStr("Eine neue Version ist verfügbar") + "<br />" +
						locStr("Ihre Version:") + " " + getBeautifulVersionnumber(myVersion) + " &mdash; " +
						locStr("Neue Version:") + " " + getBeautifulVersionnumber(latest) + "<br /><br />" +
						description +
						locStr("Möchten Sie die neue Version jetzt laden?"), locStr("Ignorieren"), blendDialogOut, locStr("Laden"), getNewVersion);
		}
	}
}


function getNewVersion()
{
	blendDialogOut();
	gotoURL("http://widgetschmie.de/widgets/" + PACKAGE_ONLINEDIR);	
}


// resets the text of the check-ling
function resetLatestVersionCheck(link) {
	if(link) {
		latest_obj = getObj(link);
	}
	if(latest_obj) {
		latest_obj.innerText = "check version";
	}
}

